var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _this = this;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import classnames from 'classnames';

import { createDynamicRule } from 'rockey/styleSheets';
import hash from 'rockey/utils/hash';

import createElement from './utils/createElement';
import { CONTEXT_KEY } from './RockeyThemeProvider';

var HANDLERS_SHOULD_BE_RESETED_ON_OUT = ['onMouseMove', 'onMouseOver'];
var HANDLERS_SHOULD_BE_RESETED_ON_OVER = ['onMouseOut'];

var reset = function reset(list, handlers, missed, forceUpdate) {
  list.forEach(function (event) {
    handlers.filter(function (handler) {
      return handler.event === event;
    }).forEach(function (handler) {
      handler.clear();

      if (!missed[handler.event]) {
        forceUpdate();
      }
    });
  });
};

var resetOnOver = function resetOnOver(handlers, missed, forceUpdate) {
  reset(HANDLERS_SHOULD_BE_RESETED_ON_OVER, handlers, missed, forceUpdate);
};

var resetOnOut = function resetOnOut(handlers, missed, forceUpdate) {
  reset(HANDLERS_SHOULD_BE_RESETED_ON_OUT, handlers, missed, forceUpdate);
};

var withHandlers = function withHandlers(_ref) {
  var props = _ref.props,
      forceUpdate = _ref.forceUpdate,
      handlers = _ref.handlers,
      missedHandler = _ref.missedHandler;

  var componentHandlers = {};
  var groupedHandlers = {};

  var resetonOut = false;
  var resetonOver = false;

  handlers.forEach(function (handler) {
    missedHandler[handler.event] = false;

    if (HANDLERS_SHOULD_BE_RESETED_ON_OUT.indexOf(handler.event) !== -1) {
      resetonOut = true;
    }

    if (HANDLERS_SHOULD_BE_RESETED_ON_OVER.indexOf(handler.event) !== -1) {
      resetonOver = true;
    }

    if (!componentHandlers[handler.event]) {
      componentHandlers[handler.event] = function (e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.persist();

        if (props[handler.event]) {
          props[handler.event].apply(props, [e].concat(args));
        }

        groupedHandlers[handler.event].forEach(function (handler) {
          handler.apply(undefined, [e].concat(args));
        });
      };
    }

    if (!groupedHandlers[handler.event]) {
      groupedHandlers[handler.event] = [];
    }

    groupedHandlers[handler.event].push(function () {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      if (handler.assign.apply(handler, args.concat([props]))) {
        missedHandler[handler.event] = false;

        forceUpdate();
      } else {
        if (!missedHandler[handler.event]) {
          forceUpdate();
        }

        missedHandler[handler.event] = true;
      }
    });
  });

  // reset handlers
  if (resetonOut) {
    var onMouseOut = componentHandlers.onMouseOut;
    componentHandlers.onMouseOut = function () {
      if (onMouseOut) {
        onMouseOut.apply(undefined, arguments);
      }

      resetOnOut(handlers, missedHandler, function () {
        _this.forceUpdate();
      });
    };
  }

  if (resetonOver) {
    var onMouseOver = componentHandlers.onMouseOver;
    componentHandlers.onMouseOver = function () {
      if (onMouseOver) {
        onMouseOver.apply(undefined, arguments);
      }

      resetOnOver(handlers, missedHandler, function () {
        forceUpdate();
      });
    };
  }

  return componentHandlers;
};

var RockeyComponent = function (_React$Component) {
  _inherits(RockeyComponent, _React$Component);

  function RockeyComponent() {
    var _ref2;

    var _temp, _this2, _ret;

    _classCallCheck(this, RockeyComponent);

    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return _ret = (_temp = (_this2 = _possibleConstructorReturn(this, (_ref2 = RockeyComponent.__proto__ || Object.getPrototypeOf(RockeyComponent)).call.apply(_ref2, [this].concat(args))), _this2), _this2.staticClassName = null, _this2.missedHandler = {}, _this2.dom = null, _temp), _possibleConstructorReturn(_this2, _ret);
  }

  // state = {
  //   varsClassName: null,
  //   staticClassName: null,
  //   dynamicClassName: null,
  // };

  // varsClassName = null;

  // dynamicClassName = null;

  _createClass(RockeyComponent, [{
    key: 'getRockeyProps',

    // dynamicRule = null;

    value: function getRockeyProps(props, context) {
      var componentProps = this.props.componentProps;

      var theme = this.context[CONTEXT_KEY];

      return Object.assign({}, props || this.props.componentProps, {
        theme: context ? context[CONTEXT_KEY] : this.context[CONTEXT_KEY]
      });
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      // NOTE: redev selector behavior
      var _props = this.props,
          rockeyCSSRule = _props.rockeyCSSRule,
          selector = _props.selector;


      var classList = rockeyCSSRule.getStaticClassList();

      // this.staticClassName = classList[selector];
      this.staticClassName = Object.values(classList).join(' ');

      if (this.props.handlers) {
        this.props.handlers.forEach(function (handler) {
          handler.clear();
        });
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      // this.dom = ReactDOM.findDOMNode(this);

      var CSSProps = this.getRockeyProps();
      this.updateCSSVariables(CSSProps);
    }

    // componentWillReceiveProps({ componentProps, rockeyCSSRule }, context) {
    // if (this.dom) {
    //   const CSSProps = this.getRockeyProps(componentProps, context);
    //   this.updateDynamicClassName(CSSProps);
    //   this.updateCSSVariables(CSSProps);
    // }
    // }

  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var CSSProps = this.getRockeyProps();
      this.updateCSSVariables(CSSProps);
    }

    // updateDynamicClassName(props) {
    // const { selector } = this.props;
    // const classList = this.props.rockeyCSSRule.getDynamicCSS(props);
    //
    // if (classList[selector]) {
    //   this.dom.classList.add(classList[selector]);
    // }
    // this.dynamicClassName = classList[selector];
    // }

  }, {
    key: 'updateCSSVariables',
    value: function updateCSSVariables(props) {
      var CSSVariables = this.props.rockeyCSSRule.getCSSVariables(props);
      var dom = ReactDOM.findDOMNode(this);
      // console.log(dom);
      Object.keys(CSSVariables).forEach(function (v) {
        // TODO: rm propterty
        dom.style.setProperty('--' + v, CSSVariables[v]);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          rockeyCSSRule = _props2.rockeyCSSRule,
          Component = _props2.Component,
          selector = _props2.selector,
          componentProps = _props2.componentProps;


      var CSSProps = this.getRockeyProps();
      var dynamicClassList = rockeyCSSRule.getDynamicCSS(CSSProps);
      // console.log(dynamicClassList);
      var className = classnames(this.staticClassName,
      // dynamicClassList[selector],
      Object.values(dynamicClassList).join(' '), componentProps.className);

      var handlers = {};
      if (this.props.handlers) {
        handlers = withHandlers({
          forceUpdate: this.forceUpdate,
          handlers: this.props.handlers,
          missedHandler: this.missedHandler
        });
      }

      return createElement(Component, Object.assign({}, componentProps, handlers, {
        className: className
      }));
    }
  }]);

  return RockeyComponent;
}(React.Component);

RockeyComponent.contextTypes = _defineProperty({}, CONTEXT_KEY, PropTypes.object);
export default RockeyComponent;