import React from 'react';
import 'react-dom';
import isString from 'lodash/isString';
import isArray from 'lodash/isArray';

import createElement from './utils/createElement';
import htmlTags from './htmlTags';

var ucfirst = function ucfirst(s) {
  return s.charAt(0).toUpperCase() + s.slice(1);
};
var counter = {};

var assignShortcuts = function assignShortcuts(rockey) {
  var _loop = function _loop(tag) {
    // ---- tag hoc lazy creation
    Object.defineProperty(rockey, tag, {
      get: function get() {
        return function () {
          if (arguments.length === 1 && isString(arguments.length <= 0 ? undefined : arguments[0])) {
            // ---- use with defined displayName
            return rockey(ucfirst(arguments.length <= 0 ? undefined : arguments[0]), tag);
          } else if (isArray(arguments.length <= 0 ? undefined : arguments[0])) {
            // ---- use as anonymys tag shortcut
            if (!counter[tag]) {
              counter[tag] = 0;
            }

            return rockey('Shortcut' + ucfirst(tag) + ++counter[tag], tag).apply(undefined, arguments);
          } else {
            return createElement(tag, arguments.length <= 0 ? undefined : arguments[0]);
          }
        };
      },
      set: function set() {
        throw new Error('Override default RockeyHoc shorcuts is disabled');
      }
    });
  };

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = htmlTags[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var tag = _step.value;

      _loop(tag);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
};

export default assignShortcuts;