import when from 'rockey/when';
import insert from 'rockey/insert';
import condition from 'rockey/condition';

import { getRockeyHoc } from './RockeyHoc';
import assignShortcuts from './assignShortcuts';
import look from './look';
import handler from './handler';

var RockeyHoc = getRockeyHoc();

var RootRockeyHoc = function RootRockeyHoc() {
  var displayName = null;
  var BaseComponent = null;
  var css = null;

  // TODO: check types
  if (arguments.length === 1) {
    BaseComponent = arguments.length <= 0 ? undefined : arguments[0];

    // if (!isString(BaseComponent)) {
    displayName = BaseComponent.name || BaseComponent.displayName;
    // }

    css = arguments.length <= 1 ? undefined : arguments[1];
  } else {
    displayName = arguments.length <= 0 ? undefined : arguments[0];
    BaseComponent = arguments.length <= 1 ? undefined : arguments[1];
    css = arguments.length <= 2 ? undefined : arguments[2];
  }

  return RockeyHoc(BaseComponent, {
    displayName: displayName,
    css: css
  });
};

RootRockeyHoc.look = look;
RootRockeyHoc.when = when;
RootRockeyHoc.condition = condition;
RootRockeyHoc.insert = insert;
RootRockeyHoc.handler = handler;

assignShortcuts(RootRockeyHoc);

export default RootRockeyHoc;
export { when };