function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import rule from 'rockey/rule';
import when from 'rockey/when';
import insert from 'rockey/insert';
import condition from 'rockey/condition';

// import isString from 'lodash/isString';

import htmlTags from './htmlTags';

import rockey from './';

var createRockeyHoc = function createRockeyHoc(BaseComponent, displayName, css) {
  if (BaseComponent.extends) {
    return BaseComponent.extends(displayName, css);
  } else {
    return rockey(displayName, BaseComponent, css);
  }
};

var look = function look(BaseComponent) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$extendBase = _ref.extendBase,
      extendBase = _ref$extendBase === undefined ? true : _ref$extendBase;

  return function () {
    var css = rule.apply(undefined, arguments);
    // const isTagComponent = isString(BaseComponent);

    return css.transform(function (tree, create) {
      var components = Object.keys(tree);
      var size = components.length;

      if (!size) {
        throw new Error('Rockey look should containt at least one root component');
      }

      var parentDisplayName = components[0];
      var baseCss = create(tree[parentDisplayName]);

      var children = {};

      for (var i = 1; i < size; i++) {
        var displayName = components[i];

        var comopnentCss = create(tree[displayName]);

        if (extendBase) {
          comopnentCss.addParent(baseCss);
        }

        var ChildRockeyHoc = createRockeyHoc(BaseComponent, displayName, comopnentCss);

        children[displayName] = ChildRockeyHoc;

        // if (!isTagComponent) {
        //   BaseComponent[displayName] = ChildRockeyHoc;
        // }
      }

      var ParentRockeyHoc = createRockeyHoc(BaseComponent, parentDisplayName, baseCss);

      // if (!isTagComponent) {
      //   BaseComponent[parentDisplayName] = ParentRockeyHoc;
      // }

      return Object.assign({}, children, _defineProperty({}, parentDisplayName, ParentRockeyHoc));
    });
  };
};

look.when = when;
look.condition = condition;
look.insert = insert;

var _loop = function _loop(tag) {
  // ---- tag hoc lazy creation
  Object.defineProperty(look, tag, {
    get: function get() {
      return function () {
        return look(tag).apply(undefined, arguments);
      };
    }
  });
};

var _iteratorNormalCompletion = true;
var _didIteratorError = false;
var _iteratorError = undefined;

try {
  for (var _iterator = htmlTags[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
    var tag = _step.value;

    _loop(tag);
  }
} catch (err) {
  _didIteratorError = true;
  _iteratorError = err;
} finally {
  try {
    if (!_iteratorNormalCompletion && _iterator.return) {
      _iterator.return();
    }
  } finally {
    if (_didIteratorError) {
      throw _iteratorError;
    }
  }
}

export default look;