function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import React from 'react';
import isString from 'lodash/isString';
import isFunction from 'lodash/isFunction';
import compose from 'recompose/compose';

import filterProps from './utils/filterProps';
import htmlTags from './htmlTags';
import rockey from './';

var ucfirst = function ucfirst(s) {
  return s.charAt(0).toUpperCase() + s.slice(1);
};

var anonCounter = 0;

var RecomposeRockeyHoc = function RecomposeRockeyHoc() {
  var displayName = null;
  var BaseComponent = null;

  // TODO: check types
  if (arguments.length === 1) {
    displayName = 'RockeyRecompose' + ++anonCounter;
    BaseComponent = arguments.length <= 0 ? undefined : arguments[0];
  } else {
    displayName = arguments.length <= 0 ? undefined : arguments[0];
    BaseComponent = arguments.length <= 1 ? undefined : arguments[1];
  }

  return function () {
    var RecomposeHoc = compose.apply(undefined, arguments)(BaseComponent);

    return rockey(ucfirst(displayName), RecomposeHoc);
  };
};

var counter = {};

var _loop = function _loop(tag) {
  // ---- tag hoc lazy creation
  Object.defineProperty(RecomposeRockeyHoc, tag, {
    get: function get() {
      return function (displayName) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        var name = null;
        var enhancers = null;

        if (isString(displayName)) {
          name = ucfirst(displayName);
          enhancers = args;
        } else if (isFunction(displayName)) {
          if (!counter[tag]) {
            counter[tag] = 0;
          }

          name = 'RecomposeShortcut' + ucfirst(tag) + ++counter[tag];
          enhancers = [displayName].concat(args);
        } else {
          throw new Error('wrong usage');
        }

        var TagComponent = function TagComponent(props) {
          return React.createElement(tag, filterProps(props));
        };

        return RecomposeRockeyHoc(name, TagComponent).apply(undefined, _toConsumableArray(enhancers));
      };
    },
    set: function set() {
      throw new Error('Override default RockeyHoc shorcuts is disabled');
    }
  });
};

var _iteratorNormalCompletion = true;
var _didIteratorError = false;
var _iteratorError = undefined;

try {
  for (var _iterator = htmlTags[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
    var tag = _step.value;

    _loop(tag);
  }
} catch (err) {
  _didIteratorError = true;
  _iteratorError = err;
} finally {
  try {
    if (!_iteratorNormalCompletion && _iterator.return) {
      _iterator.return();
    }
  } finally {
    if (_didIteratorError) {
      throw _iteratorError;
    }
  }
}

export default RecomposeRockeyHoc;